package com.zipcodewilmington.phonebook;

import org.junit.Assert;
import org.junit.Test;

import java.util.ArrayList;

import static org.junit.Assert.assertEquals;

/**
 * Created by leon on 1/23/18.
 */
public class PhoneBookTest {

    private static final int Expected =0;

    @Test
    public void testHasEntry() {
        //Given
        PhoneBook book = new PhoneBook();
        String name = "Chaitali";
        String phoneNumber = "211-111-2222";

        book.hasEntry(name);

        boolean actualValue = book.hasEntry(name);

        Assert.assertTrue(actualValue);
    }
    @Test
    public void testAdd() {
        //Given - setup the data
        PhoneBook book = new PhoneBook();
        String name = "Chaitali";
        String phoneNumber = "211-111-2222";
        String phoneNumber2 = "211-111-2224";
        ArrayList<String> phonenum = new ArrayList<String>();
        phonenum.add(phoneNumber);
        phonenum.add(phoneNumber2);
        book.addRecord(name, phonenum);
        boolean actual = book.hasEntry(name);
        boolean expected = true;

        // then - verify
        Assert.assertEquals( actual , expected);
    }

    @Test
    public void testLookup() {
        //Given - setup the data
        PhoneBook book = new PhoneBook();
        String name = "Chaitali";
        String phoneNumber = "211-111-2222";
        String phoneNumber2 = "211-111-2224";
        ArrayList<String> phonenum = new ArrayList<String>();
        phonenum.add(phoneNumber);
        phonenum.add(phoneNumber2);
        book.addRecord(name, phonenum);
        book.lookUp(name);

        // when - calling the method you're testing
        String actualNumber = book.lookUp(name);
        String expected = "211-111-2222\n211-111-2224";

        // then - verify
        Assert.assertEquals(expected,actualNumber);
    }
    @Test
    public void testremove() {
        //Given - setup the data
        PhoneBook book = new PhoneBook();
        String name = "Chaitali";
        String phoneNumber = "211-111-2222";
        String phoneNumber2 = "211-111-2224";
        ArrayList<String> phonenum = new ArrayList<String>();
        phonenum.add(phoneNumber);
        phonenum.add(phoneNumber2);
        book.addRecord(name, phonenum);


        //when - calling the method you're testing
        book.removeRecods(name);

        //then - verify
        Assert.assertEquals(0,book.getSize());
    }
    @Test
    public void testreverseLookup() {
        //Given - setup the data
        PhoneBook book = new PhoneBook();
        String name = "Chaitali";
        String phoneNumber = "211-111-2222";
        String phoneNumber2 = "211-111-2224";
        ArrayList<String> phonenum = new ArrayList<String>();
        phonenum.add(phoneNumber);
        phonenum.add(phoneNumber2);
        book.addRecord(name, phonenum);


        //when-calling the method
        //String reverseLookup = book.reverseLookup(phoneNumber);
        String actualNumber = book.reverseLookup(phoneNumber);
        String expected = name;

        // then - verify
        Assert.assertEquals(expected,actualNumber);
    }
    @Test
    public void testLastNameAndNumbers() {
        //Given - setup the data
        PhoneBook book = new PhoneBook();
        String name = "Chaitali";
        String phoneNumber = "211-111-2222";
        String phoneNumber2 = "211-111-2224";
        ArrayList<String> phonenum = new ArrayList<String>();
        phonenum.add(phoneNumber);
        phonenum.add(phoneNumber2);
        book.addRecord(name, phonenum);

        //When - calling the method
        book.ListNamesandNumbers();
        String actualNumber = book.ListNamesandNumbers();
        String expected = "{" + name + "=[" + phoneNumber + ", " + phoneNumber2 + "]}";

        // then - verify
       Assert.assertEquals(expected,actualNumber);

    }
//    @Test
//    public void getContacts() {
//        //Given - setup the data
//        PhoneBook book = new PhoneBook();
//        String name = "Chaitali";
//        String phoneNumber = "211-111-2222";
//
//        book.getContacts(phoneNumber);
//
//        //When - calling the method you're testing
//        String contacts = book.getContacts(phoneNumber);
//    }

    @Test
    public void size() {

    }
}
